; *******************************************************************************
; Rotate bitmap (bpp=32)
;
; (softKUS) - VI/2004
; *******************************************************************************

.486
.MODEL FLAT

.CODE
_run:

include         ..\stdparas.inc                         ; PA1-PA4
include         ..\abpstruc.inc                         ; asmBmpPara-structure

; *******************************************************************************

abp             EQU     <PA1>                           ; ptr: asmBmpPara
dbl             EQU     <PA2>                           ; ptr: doublearray
msk             EQU     <PA3>                           ; lng: mask color
flg             EQU     <PA4>                           ; lng: flags

flg_antiA       EQU     1
flg_useMsk      EQU     2
flg_autoMsk     EQU     4
flg_fillMsk     EQU     8
flg_Adjust      EQU     16
; -------------------------
flg_Bitmask     EQU     1Fh
flg_Written     EQU     20h                             

dbl_Angle       EQU     0
dbl_ACos        EQU     8
dbl_ASin        EQU     16
dbl_ACosByX     EQU     24
dbl_ACosByY     EQU     32
dbl_ASinByX     EQU     40
dbl_ASinByY     EQU     48
dbl_ActX        EQU     56
dbl_ActY        EQU     64
dbl_DfltAA      EQU     72


MaxCol          EQU     <stack1>
MinCol          EQU     <stack2>
MskCol          EQU     <stack3>
TgtPtr          EQU     <stack4>
ActFlg          EQU     <stack5>
intX            EQU     <DWord Ptr [esi+88]>
intY            EQU     <DWord Ptr [esi+84]>
chgCW           EQU     <Word  Ptr [esi+82]>
svdCW           EQU     <Word  Ptr [esi+80]>            ; <=> <stack8>
actX            EQU     <QWord Ptr [esi+72]>
actY            EQU     <QWord Ptr [esi+64]>
svdX            EQU     <QWord Ptr [esi+56]>
svdY            EQU     <QWord Ptr [esi+48]>
rmdX            EQU     <QWord Ptr [esi+40]>
rmdXa           EQU     <QWord Ptr [esi+32]>
rmdY            EQU     <QWord Ptr [esi+24]>
rmdYa           EQU     <QWord Ptr [esi+16]>
pnt4            EQU     <DWord Ptr [esi+12]>                    ; last four values!
pnt3            EQU     <DWord Ptr [esi+08]>
pnt2            EQU     <DWord Ptr [esi+04]>
pnt1            EQU     <DWord Ptr [esi+00]>
; --------------------------------------------------
varLen          EQU     92

; *******************************************************************************

Rotate          PROC    NEAR
                mac     SAVE
                mov     ebx,abp
                mov     esi,srcBits
                mov     edi,tgtBits
                mov     edx,tgtHeight

                xor     eax,eax
                push    eax                             ; => MaxCol
                dec     eax
                push    eax                             ; => MinCol

                mov     eax,msk
                test    flg,flg_autoMsk
                jz      init_1
                lodsd
init_1:         bswap   eax
                shr     eax,8
                push    eax                             ; => MskCol
                push    edi                             ; => TgtPtr
                mov     ecx,flg
                xor     cl,(flg_useMsk+flg_Adjust)
                and     ecx,flg_Bitmask
                push    ecx                             ; => ActFlg
                
                test    cl,flg_fillMsk                  ; "initialize target buffer"
                jz      init_2
                mov     ecx,tgtWidth
                imul    ecx,edx
                rep     stosd
                
init_2:         sub     esp,varLen                      ; "init stack variables"
                mov     esi,esp
                                
                fstcw   svdCW                           ; "init fpu"
                mov     eax,stack8                      ; (chgCW/svdCW)
                or      ah,0Ch                          ; (truncate)
                mov     chgCW,ax
                fldcw   chgCW

                mov     eax,dbl
                fldz
                fld     QWord Ptr [eax+dbl_DfltAA]
                fld     QWord Ptr [eax+dbl_ActX]
                fld     QWord ptr [eax+dbl_ActY]

lpRow:          push    edx                             ; "row loop"
                fld     st(1)
                fstp    svdX
                fst     svdY
                mov     ecx,tgtWidth                    ; "column loop"

lpCol:          push    ecx
                fld1
                fld     st(2)                           ; (actX)
                fist    intX
                fisub   intX
                fabs
                fcom    st(5)                           ; (zero)
                fstsw   ax
                fwait
                sahf
                jnz     lpCol_a
                fadd    st(0),st(4)                     ; (dfltAA)
lpCol_a:        fstp    rmdXa
                fsub    rmdXa
                fstp    rmdX

                fld1
                fld     st(1)
                fist    intY
                fisub   intY
                fabs
                fcom    st(5)
                fstsw   ax
                fwait
                sahf
                jnz     lpCol_b
                fadd    st(0),st(4)
lpCol_b:        fstp    rmdYa
                fsub    rmdYa
                fstp    rmdY                                                

                mov     ecx,intX
                cmp     ecx,srcWidth
                jge     lpCol3

                mov     edi,intY
                cmp     edi,srcHeight
                jge     lpCol3

                test    flg,flg_antiA
                jz      lpCol1

antiA:          xor     eax,eax
                cdq
                dec     edx
                cmp     ecx,edx
                jl      lpCol3
                cmp     edi,edx
                jl      lpCol3

                or      ecx,ecx
                js      antiA_1a
                or      al,1
antiA_1a:       inc     ecx
                cmp     ecx,srcWidth
                jge     antiA_1b
                or      al,2
antiA_1b:       or      edi,edi
                js      antiA_1c
                or      al,4
antiA_1c:       inc     edi
                cmp     edi,srcHeight
                jge     antiA_2
                or      al,8

antiA_2:        dec     ecx
                dec     edi
                imul    edi,srcWidthBytes
                add     edi,srcBits
                lea     edi,[edi+4*ecx]                 ; edi => off srcBuffer

                push    ebx
                call    antiA_2a
antiA_2a:       pop     ebx
                add     ebx,(OffSet flg_lst - OffSet antiA_2a)
                xlat                                    ; al  => transformed flag
                pop     ebx
                
                mov     ecx,TgtPtr
antiA_3:        test    al,1                                
                jz      antiA_3a1
                call    rou1
                jnz     antiA_3a2
antiA_3a1:      mov     edx,[ecx]
antiA_3a2:      mov     pnt1,edx
                add     edi,4
                test    al,2
                jz      antiA_3b1
                call    rou1
                jnz     antiA_3b2
antiA_3b1:      mov     edx,[ecx]
antiA_3b2:      mov     pnt2,edx
                add     edi,srcWidthBytes
                test    al,8
                jz      antiA_3c1
                call    rou1
                jnz     antiA_3c2
antiA_3c1:      mov     edx,[ecx]
antiA_3c2:      mov     pnt4,edx        
                sub     edi,4
                test    al,4
                jz      antiA_3d1
                call    rou1
                jnz     antiA_3d2
antiA_3d1:      mov     edx,[ecx]
antiA_3d2:      mov     pnt3,edx

                mov     ecx,2
                mov     dl,ch
lpAntiA:        shl     edx,8
                xor     eax,eax
                mov     al,[esi+ecx]                    ; (pnt1)
                push    eax
                fild    DWord Ptr [esp]
                fmul    rmdX
                fmul    rmdY
                pop     eax

                mov     al,[esi+ecx+4]
                push    eax
                fild    DWord Ptr [esp]
                fmul    rmdXa
                fmul    rmdY
                faddp   st(1),st(0)
                pop     eax

                mov     al,[esi+ecx+8]
                push    eax
                fild    DWord Ptr [esp]
                fmul    rmdX
                fmul    rmdYa
                faddp   st(1),st(0)
                pop     eax
                
                mov     al,[esi+ecx+12]
                push    eax
                fild    DWord Ptr [esp]
                fmul    rmdXa
                fmul    rmdYa
                faddp   st(1),st(0)
                fistp   DWord Ptr [esp]
                pop     eax

                mov     dl,al
                dec     ecx
                jns     lpAntiA

                call    rou1_a
                jmp     lpCol2
                
lpCol1:         or      ecx,ecx
                js      lpCol3
                or      edi,edi
                js      lpCol3

                imul    edi,srcWidthBytes
                add     edi,srcBits
                lea     edi,[edi+4*ecx]
                call    rou1

lpCol2:         jz      lpCol3
                mov     edi,TgtPtr
                mov     [edi],edx
                test    flg,flg_Adjust
                jz      lpCol3

                or      ActFlg,flg_Written                      ; validate row
                mov     eax,tgtWidth
                sub     eax,[esp]
                cmp     eax,MinCol
                jnc     lpCol2_a
                mov     MinCol,eax                             ; set min/max col in use
lpCol2_a:       cmp     MaxCol,eax
                jnc     lpCol3
                mov     MaxCol,eax
                                
lpCol3:         add     TgtPtr,4
                mov     eax,dbl
                fld     Qword Ptr [eax+dbl_ACosByX]
                faddp   st(2),st(0)
                fld     QWord Ptr [eax+dbl_ASinByY]
                faddp   st(1),st(0)
                pop     ecx
                dec     ecx
                jnz     lpCol
                                
                fistp   intY
                fistp   intX
                test    ActFlg,(flg_Adjust+flg_Written)
                jnz     lpCol3_a
                mov     edx,tgtWidthBytes                       ; reset TgtPtr, if row is invalid
                sub     TgtPtr,edx
lpCol3_a:       pop     edx
                dec     edx
                jz      lpEnd
                
                fld     svdX
                fsub    QWord Ptr [eax+dbl_ASinByX]
                fld     svdY
                fadd    QWord Ptr [eax+dbl_ACosByY]
                jmp     lpRow
                

flg_lst         db      0,0,0,0,0,1,2,3,0,4,8,12,0,5,10,15                                    

rou1:           mov     edx,[edi]
                shl     edx,8
                shr     edx,8
rou1_a:         test    ActFlg,flg_useMsk
                jnz     rou1_b
                cmp     edx,MskCol
rou1_b:         ret


lpEnd:          fstp    svdY                            ; (delete dfltAA)
                fstp    svdX                            ; (delete zero)
                fldcw   svdCW

                test    flg,flg_Adjust
                jz      finish
                mov     eax,TgtPtr
                sub     eax,tgtBits
                cdq
                div     tgtWidthBytes
                xchg    eax,tgtHeight
                sub     eax,tgtHeight
                sub     tgtHeight,eax

                mov     esi,MinCol
                mov     eax,MaxCol
                sub     eax,esi
                inc     eax
                xchg    eax,tgtWidth
                sub     eax,tgtWidth
                jz      finish
                
                shl     eax,2
                sub     tgtWidthBytes,eax
                
                mov     edi,tgtBits
                lea     esi,[edi+4*esi]
                mov     ecx,tgtWidthBytes
                shr     ecx,2
                mov     edx,tgtHeight
lpAdjust:       push    ecx
                rep     movsd
                pop     ecx
                add     esi,eax
                dec     edx
                jnz     lpAdjust                                                         

finish:         stc
                mac     RESTSP
Rotate          ENDP

END _run
